# -*- coding: utf-8 -*-
"""
/***************************************************************************
 MatchingVectorial
                                 A QGIS plugin
 Plugin que realiza matching vectorial entre puntos y polígonos.
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2018-05-14
        git sha              : $Format:%H$
        copyright            : (C) 2018 by Carlos Lapuente - UOC
        email                : clapuente@uoc.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from PyQt5.QtCore import QSettings, QTranslator, qVersion, QCoreApplication
from PyQt5.QtGui import QIcon
from PyQt5.QtWidgets import QAction
from qgis.core import *
import processing


# Initialize Qt resources from file resources.py
from .resources import *
# Import the code for the dialog
from .matching_vectorial_dialog import MatchingVectorialDialog
import os.path


class MatchingVectorial:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'MatchingVectorial_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)

            if qVersion() > '4.3.3':
                QCoreApplication.installTranslator(self.translator)

        # Create the dialog (after translation) and keep reference
        self.dlg = MatchingVectorialDialog()

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&Matching Vectorial')
        # TODO: We are going to let the user set this up in a future iteration
        self.toolbar = self.iface.addToolBar(u'MatchingVectorial')
        self.toolbar.setObjectName(u'MatchingVectorial')

    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('MatchingVectorial', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            self.toolbar.addAction(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/matching_vectorial/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u'Matching Vectorial'),
            callback=self.run,
            parent=self.iface.mainWindow())


    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&Matching Vectorial'),
                action)
            self.iface.removeToolBarIcon(action)
        # remove the toolbar
        del self.toolbar

    def run(self):
        """Run method that performs all the real work"""
        # show the dialog
        self.dlg.show()
        # Run the dialog event loop
        result = self.dlg.exec_()
        # Comprueba si se ha pulsado Aceptar (OK)
        if result == 1:
        
            # Hace un listado de todas las capas cargadas en QGIS
            layers = QgsProject.instance().mapLayers().values()
            
            # Busca cual es la capa con el nombre EDIFICIOS...
            for layer in layers:
                if layer.name() == "EDIFICIOS":
                    # ... averigua la ruta en el disco duro de esta capa ... y
                    myfilepath_EDIFICIOS = layer.dataProvider().dataSourceUri()
                    # ... deduce el nombre de la ruta hasta la carpeta que la contiene y el nombre del fichero shape
                    (myDirectory_EDIFICIOS,nameFile_EDIFICIOS) = os.path.split(myfilepath_EDIFICIOS)
            
            # Lo mismo que el bloque anterior de código pero para la capa PUNTOS (PoI)
            for layer in layers:
                if layer.name() == "PUNTOS":
                    myfilepath_PUNTOS = layer.dataProvider().dataSourceUri()
                    (myDirectory_PUNTOS,nameFile_PUNTOS) = os.path.split(myfilepath_PUNTOS)
                    
            # Ruta donde se guardará la capa resultante de la union de atributos por localizacion Capa_matching_vectorial (en formato shapefile).         
            OUTPUT = str(myDirectory_EDIFICIOS) + '/' + 'Capa_matching_vectorial.shp'
            
			# Parametros del geoproceso de union de atributos por localizacion.
				#INPUT: Capa de entrada (puntos).
				#JOIN: Capa que hará el matching (edificios).
				#PREDICATE: [5]= Predicado geométrico "dentro".
				#DISCARD_NONMATCHING [True]= Descartará los que no cumplan el predicado geométrico. 
            parameters = {'INPUT':myfilepath_PUNTOS,'JOIN': myfilepath_EDIFICIOS,'PREDICATE':[5],'JOIN_FIELDS':[],'METHOD':0,'DISCARD_NONMATCHING':True,'OUTPUT':OUTPUT}
            feedback = QgsProcessingFeedback()
			
            # Ejecución del geoproceso y carga en el proyecto de la capa resultante Capa_matchimp_vectorial
            processing.runAndLoadResults("qgis:joinattributesbylocation", parameters, feedback = feedback)

            # Dar el estilo de simbolización deseado (como se almacenará la capa en QGIS y en el disco duro).
            STYLE = str(myDirectory_EDIFICIOS) + '/' + 'Capa_matching_vectorial.qml'
            Capa_unida = QgsProject.instance().mapLayersByName('Capa unida')[0]
            Capa_unida.loadNamedStyle(STYLE)
            pass